# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without axis
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/apache-scout/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define short_name scout
%define section free

Name:           ws-scout
Version:        1.1.1
Release:        3.4.3%{?dist}
Epoch:          0
Summary:        Apache Scout Implementation of JSR 93 (JAXR)
License:        ASL 2.0
Group:          Text Processing/Markup/XML
URL:            http://ws.apache.org/scout/
# svn export https://svn.apache.org/repos/asf/webservices/scout/tags/scout-1.1.1/ ws-scout-1.1.1-src
# Exported revision 807281.
# tar czf ws-scout-1.1.1-src.tgz ws-scout-1.1.1-src
Source0:        %{name}-%{version}-src.tgz
Source1:        %{name}-component-info.xml
Source2:        %{name}-depmap.xml
Source3:	ws-scout-upload.sh
Patch0:         ws-scout-pom.patch
Patch1:         ws-scout-no-axis.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
%if 0
Requires:       axis >= 0:1.4
%endif
Requires:       jaf
Requires:       jakarta-commons-discovery
Requires:       jakarta-commons-logging
Requires:       jdom
Requires:       juddi
BuildRequires:  codehaus-stax11-api
BuildRequires:  jpackage-utils
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-clean
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-shade-plugin
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-shared
BuildRequires:  maven-shared-file-management
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven-surefire
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-wagon
BuildRequires:  plexus-archiver
BuildRequires:  plexus-compiler
BuildRequires:  plexus-containers-container-default
BuildRequires:  plexus-i18n
BuildRequires:  plexus-utils
BuildRequires:  plexus-velocity
BuildRequires:  felix-maven2
BuildRequires:  axis >= 0:1.4
BuildRequires:  derby
BuildRequires:  geronimo-jaf-1.1-api
# FIXME: Why our geronimo-specs does not have jaxb?
%if 0
BuildRequires:  geronimo-jaxb-2.1-api
%endif
BuildRequires:  glassfish-jaxb
BuildRequires:  geronimo-jaxr-1.0-api
BuildRequires:  geronimo-jaxrpc-1.1-api
# FIXME: Our geronimo-specs only has the SAAJ 1.1
%if 0
BuildRequires:  geronimo-saaj-1.3-api
%endif
BuildRequires:  geronimo-saaj-1.1-api
BuildRequires:  jaf
BuildRequires:  jakarta-commons-discovery
BuildRequires:  jakarta-commons-logging
BuildRequires:  jdom
BuildRequires:  juddi
BuildRequires:  junit
BuildRequires:  saxon-scripts
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache Scout is an implementation of the 
JSR 93 (JAXR). 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{name}-%{version}-src
%patch0 -p0 -b .sav0
%if %without axis
%patch1 -p0 -b .sav1
%{__rm} src/main/java/org/apache/ws/scout/transport/AxisTransport.java
%endif

cp -p %{SOURCE2} %{name}-depmap.xml

find . -name "*.jar" -exec rm -f {} \;

#Update groupId to match with r.j.o/m2-brew
sed -i -e 's:<groupId>org.apache.ws.scout</groupId>:<groupId>apache-scout</groupId>:' pom.xml

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
export MAVEN_DEPMAP=$(pwd)/%{name}-depmap.xml
%{_bindir}/mvn-jpp -e \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=${MAVEN_DEPMAP} \
        -Dmaven.test.skip=true \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 644 target/scout-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar

# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
ln -s %{name}-%{version}.jar %{short_name}-%{version}.jar
for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done
)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.apache.ws.scout scout %{version} JPP %{name}
%add_to_maven_depmap apache-scout scout %{version} JPP %{name}

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
%if %without axis
install -p -m 644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
%endif
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/scout.jar
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/scout.pom

%{__install} -p -m 755 %{SOURCE3} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE NOTICE README
%dir %{_javadir}*/%{name}
%{_javadir}*/%{name}/%{name}-%{version}.jar
%{_javadir}*/%{name}/%{name}.jar
%{_javadir}*/%{name}/%{short_name}-%{version}.jar
%{_javadir}*/%{name}/%{short_name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Jan 21 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.1.1-3.4.3
- Fix groupId to apache-scout for proper repolib content
- Fix packaging for uploading script

* Wed Dec 01 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.1.1-3.4.2
- Build with Maven 2.2.1
- Change BR maven2-plugin-shade to maven-shade-plugin
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR mavne-deploy-plugin
- Add the line to find and remove any binaries
- Add BR codehaus-stax11-api

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.1-3.4.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.1.1-3.4
- Rebuild

* Mon Mar 22 2010 David Walluck <dwalluck@redhat.com> 0:1.1.1-3.3
- enable axis support at build time

* Thu Feb 25 2010 David Walluck <dwalluck@redhat.com> 0:1.1.1-3.2
- bump release

* Thu Feb 25 2010 David Walluck <dwalluck@redhat.com> 0:1.1.1-3.1
- make axis optional
- fix jpackage-utils Requires
- fix component-info.xml
- remove BuildRoot in install

* Fri Nov 20 2009 Martha Benitez <mbenitez@redhat.com> 0:1.1.1-3
- Add repolib

* Wed Nov 04 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.1-2
- Patch pom so it works (more or less) with older versions of the bundle plugin

* Mon Aug 24 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.1-1
- Upgrade to 1.1.1

* Thu May 21 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0-5.1
- Change jpackage-utils >= 0:1.6 to jpackage-utils >= 0:1.3

* Wed Jul 09 2008 Fernando Nasser <fnasser@redhat.com> 0:1.0-5
- Saxon-scripts is required for building

* Mon Feb 13 2006 Ralph Apel <r.apel@r-apel.de> 0:1.0-4jpp
- Switch to require jaf, as provided by geronimo-specs

* Wed Dec 07 2005 Fernando Nasser <fnasser@redhat.com> 0:1.0-3jpp
- First JPP 1.7 build

* Wed Aug 17 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-2jpp
- Improve multiproject treatment *THIS CHANGE MAY HAVE BEEN LOST IN THE MERGE*

* Tue Jul 26 2005 Deepak Bhole <dbhole@redhat.com> 0:1.0-1jpp_2rh
- Removed the log4j.properties file (may cause problems with other packages).

* Tue Jul 26 2005 Deepak Bhole <dbhole@redhat.com> 0:1.0-1jpp_1rh
- First Red Hat build.
- Update to use maven-1.0.2 (and it's symlink to /usr/share/java in the repo).
- Removed spurious dependencies.
- Use generic activation jar instead of the geronimo-sandbox one.

* Tue Jul 26 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-1jpp
- First JPackage release
